# OTT mirror
# Copyright (C) 2014 Balthasar Szczepański
# post.awk
# send a post.
# 12.09.2014

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	FS="="
###fora
###USERAGENT3a
};
{
	eq=index($0,"=")
	argtab[substr($0,1,eq-1)]=substr($0,eq+1)
};
END{
	if(system("wget -q -t 3 --connect-timeout=60 --save-cookies=" cookiefile " -U " useragent " -O " tempfile " " fora "/ucp.php?mode=login"))
	{
		print "Pre-login fail."
		exit 1
	}
	while((getline cookie < cookiefile)>0)
	{
		if(cookie ~ /_sid/)
		{
			split(cookie,arr,"_sid[ \t]*")
			SID=arr[2]
		}
	}
	close(cookiefile)
	print "username=" argtab["username"] "&password=" argtab["password"] "&sid=" SID "&login=Login" > postfile
	close(postfile)
	if(system("wget -q -t 3 --connect-timeout=60 --save-cookies=" cookiefile " --post-file=" postfile " -U " useragent " -O " tempfile " \"" fora "/ucp.php?mode=login\""))
	{
		print "Login fail."
		exit 1
	}
	
	while((getline temp < tempfile)>0)
	{
		if (temp ~ /<div class=.error/)
		{
			print temp
			print "LOGIN IMPOSSIBLE!"
			exit 2
		}
	}
	close(tempfile)
	
	if(system("wget -q -t 3 --connect-timeout=60 --load-cookies=" cookiefile " --save-cookies=" cookiefile " -U " useragent " -O " tempfile " \"" fora "/posting.php?mode=reply&f=7&t=101043\""))
	{
		print "Postreply fail."
		exit 1
	}
	
	while((getline temp < tempfile)>0)
	{
		if(temp ~ /name=\"form_token/)
		#\"#"
		{
			split(temp,arr,"(value=\")|(\" ?/>)")
			argtab["form_token"]=arr[2]
		}
		if(temp ~ /name=\"creation_time/)
		#\"#"
		{
			split(temp,arr,"(value=\")|(\" ?/>)")
			argtab["creation_time"]=arr[2]
		}
		if (tolower(temp) ~ /<h2>information/)
		{
			print "Unexpected h2: information\n"
			getline temp < tempfile
			print temp
			exit 1
		}
	}
	close(tempfile)
	
	printf ("subject=%s",argtab["subject"])>postfile
	if("&addbbcode20" in argtab)
		printf ("&addbbcode20=%s",argtab["addbbcode20"])>>postfile
	printf ("&message=%s",argtab["message"])>>postfile
	printf ("&post=%s","Submit")>>postfile
	if("disable_bbcode" in argtab)
		printf ("&disable_bbcode=%s",argtab["disable_bbcode"])>>postfile
	if("disable_smilies" in argtab)
		printf ("&disable_smilies=%s",argtab["disable_smilies"])>>postfile
	if("disable_magic_url" in argtab)
		printf ("&disable_magic_url=%s",argtab["disable_magic_url"])>>postfile
	if("attach_sig" in argtab)
		printf ("&attach_sig=%s",argtab["attach_sig"])>>postfile
	if("notify" in argtab)
		printf ("&notify=%s",argtab["notify"])>>postfile
	printf ("&creation_time=%s",argtab["creation_time"])>>postfile
	printf ("&form_token=%s",argtab["form_token"])>>postfile
	close(postfile)
	
	if(system("wget -q -t 3 --connect-timeout=60 --load-cookies=" cookiefile " --save-cookies=" cookiefile " --post-file=" postfile " -U " useragent " -O " tempfile " \""fora "/posting.php?mode=reply&f=7&t=101043\""))
	{
		print "Submit fail."
		exit 1
	}
	
	while((getline temp < tempfile)>0)
	{
		if (temp ~ /<p class=.error/)
		{
			print temp
			print "POST IMPOSSIBLE!"
			exit 2
		}
		if (tolower(temp) ~ /<h2>information/)
		{
			success=1
		}
	}
	close(tempfile)
	
	if (success!=1)
	{
		print "Sent back to preview!"
		exit INDELIVERABLE
	}
	
	while((getline cookie < cookiefile)>0)
	{
		if(cookie ~ /_sid/)
		{
			split(cookie,arr,"_sid[ \t]*")
			SID=arr[2]
			break
		}
	}
	close(cookiefile)
	if(system("wget -q -t 3 --connect-timeout=60 -U " useragent " -O " tempfile " \"" fora "/ucp.php?mode=logout&sid=" SID"\""))
	{
		print "Logout fail."
	}
	
 
}
