# OTT mirror
# Copyright (C) 2014 Balthasar Szczepański
# pm.awk
# send a PM.
# 12.09.2014

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	FS="="
###fora
###USERAGENT3a
	prefix1="This%20is%20an%20automaticly%20generated%20message%20from%20the%20%5Burl%3D###own_url_encoded;%5D%D0%AFO%D0%AF%D0%AFIM%20TTO%5B%2Furl%5D.%0AYour%20post%20couldn%27t%20be%20posted.%0AThe%20%5Burl%3D###own_url_encoded;%2Flog%2Fbot3.log%5Dlog%5B%2Furl%5D%20may%20help%20you%20determine%20the%20reasons%20for%20this.%5Bquote%3D%22%5Bcolor%3D%230000FF%5D"
	prefix2="%5B%2Fcolor%5D%22%5D"
	postfix="%5B%2Fquote%5D%5Bright%5D%5Bsize%3D85%5D--%20posted%20by%20###bot3name_encoded;%5B%2Fsize%5D%5B%2Fright%5D"
	OK=0
	MUSTARD=1
	INDELIVERABLE=2
};
{
	eq=index($0,"=")
	argtab[substr($0,1,eq-1)]=substr($0,eq+1)
};
END{
	if(system("wget -q -t 3 --connect-timeout=60 --save-cookies=" cookiefile " -U " useragent " -O " tempfile " " fora "/ucp.php?mode=login"))
	{
		print "Pre-login fail."
		exit MUSTARD
	}
	while((getline cookie < cookiefile)>0)
	{
		if(cookie ~ /_sid/)
		{
			split(cookie,arr,"_sid[ \t]*")
			SID=arr[2]
		}
	}
	close(cookiefile)
	print "username=" name "&password=" pass "&sid=" SID "&login=Login" > postfile
	close(postfile)
	if(system("wget -q -t 3 --connect-timeout=60 --save-cookies=" cookiefile " --post-file=" postfile " -U " useragent " -O " tempfile " \"" fora "/ucp.php?mode=login\""))
	{
		print "Login fail."
		exit MUSTARD
	}
	
	while((getline temp < tempfile)>0)
	{
		if (temp ~ /<div class=.error/)
		{
			print temp
			print "LOGIN IMPOSSIBLE!"
			exit INDELIVERABLE
		}
	}
	close(tempfile)
	
	if(system("wget -q -t 3 --connect-timeout=60 --load-cookies=" cookiefile " --save-cookies=" cookiefile " -U " useragent " -O " tempfile " \"" fora "/ucp.php?i=pm&mode=compose&action=post&username_list=" argtab["username"] "&add_to=Add\""))
	{
		print "NewPM fail."
		exit MUSTARD
	}
	
	while((getline temp < tempfile)>0)
	{
		if(temp ~ /name=\"form_token/)
		#\"#"
		{
			split(temp,arr,"(value=\")|(\" ?/>)")
			argtab["form_token"]=arr[2]
		}
		if(temp ~ /name=\"creation_time/)
		#\"#"
		{
			split(temp,arr,"(value=\")|(\" ?/>)")
			argtab["creation_time"]=arr[2]
		}
		if(temp ~ /name=\"address_list/)
		#\"#"
		{
			split(temp,arr,"(address_list\[u\]\[)|(\]\")")
			argtab["address_list"]=arr[2]
		}
		if (temp ~ /<p class=\"error/)
		#\"#"
		{
			print temp
			print "NOBODY WITH THAT NAME"
			exit INDELIVERABLE
		}
	}
	close(tempfile)
	
	printf ("icon=10")>postfile
	printf ("&subject=Mirrorpost%%20failed")>postfile
	if("&addbbcode20" in argtab)
		printf ("&addbbcode20=%s",argtab["addbbcode20"])>>postfile
	printf ("&message=%s%s%%3A%%20%s%s%s%s",prefix1,argtab["timenumber"],argtab["subject"],prefix2,argtab["message"],postfix)>>postfile
	printf ("&address_list%%5Bu%%5D%%5B%s%%5D=to",argtab["address_list"])>>postfile
	printf ("&post=Submit")>postfile
	if("disable_smilies" in argtab)
		printf ("&disable_smilies=%s",argtab["disable_smilies"])>>postfile
	if("disable_magic_url" in argtab)
		printf ("&disable_magic_url=%s",argtab["disable_magic_url"])>>postfile
	printf ("&creation_time=%s",argtab["creation_time"])>>postfile
	printf ("&form_token=%s",argtab["form_token"])>>postfile
	close(postfile)
	
	if(system("wget -q -t 3 --connect-timeout=60 --load-cookies=" cookiefile " --save-cookies=" cookiefile " --post-file=" postfile " -U " useragent " -O " tempfile " \""fora "/ucp.php?i=pm&mode=compose&action=post\""))
	{
		print "Submit fail."
		exit MUSTARD
	}
	
	while((getline temp < tempfile)>0)
	{
		if (temp ~ /<p class=.error/)
		{
			print temp
			print "POST IMPOSSIBLE!"
			exit INDELIVERABLE
		}
		if (tolower(temp) ~ /<h2>information/)
		{
			success=1
		}
	}
	close(tempfile)
	
	if (success!=1)
	{
		print "Sent back to preview!"
		exit INDELIVERABLE
	}
	
	while((getline cookie < cookiefile)>0)
	{
		if(cookie ~ /_sid/)
		{
			split(cookie,arr,"_sid[ \t]*")
			SID=arr[2]
			break
		}
	}
	close(cookiefile)
	if(system("wget -q -t 3 --connect-timeout=60 -U " useragent " -O " cookiefile " \"" fora "/ucp.php?mode=logout&sid=" SID"\""))
	{
		print "Logout fail."
	} 
}
